"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.logger = exports.crosslabTransport = void 0;
const winston_1 = __importDefault(require("winston"));
const winston_transport_1 = __importDefault(require("winston-transport"));
class CrosslabTransport extends winston_transport_1.default {
    constructor() {
        super(...arguments);
        this.buffer = [];
        this.upstream = () => { };
    }
    log(info, callback) {
        try {
            this.upstream(info);
        }
        catch (e) {
            this.buffer.push(info);
        }
        if (callback)
            callback();
    }
    _set_upstream(upstream) {
        this.upstream = upstream;
        const bufferCopy = this.buffer.slice();
        this.buffer = [];
        bufferCopy.forEach(info => this.log(info, undefined));
    }
}
exports.crosslabTransport = new CrosslabTransport();
exports.logger = winston_1.default.createLogger({
    transports: exports.crosslabTransport,
    levels: {
        fatal: 0,
        error: 1,
        warn: 2,
        info: 3,
        debug: 4,
        trace: 5,
    },
});
//# sourceMappingURL=logging.js.map